set serveroutput on
declare
  v_my_transaction  pls_integer;
  v_xa_xid     dbms_xa_xid := dbms_xa_xid('&1');
  v_xa_exception exception;
  v_ora_error pls_integer;
begin
  v_my_transaction  := dbms_xa.xa_start(
                          xid => v_xa_xid,
                          flag =>  dbms_xa.tmnoflags);

--Check if XA transaction is OK
  if v_my_transaction <> dbms_xa.xa_ok then
    v_ora_error := dbms_xa.xa_getlastoer();
    dbms_output.put_line(a => 'Attention! Oracle Error - ORA-' || v_ora_error || ' obtained. XA Process failed!');
    raise v_xa_exception;
  else dbms_output.put_line(a => 'XA Process ID &1 started');
  end if;
  v_my_transaction  := dbms_xa.xa_end(xid => v_xa_xid,flag =>  dbms_xa.tmsuspend);

--Check if XA transaction is OK
  if v_my_transaction <> dbms_xa.xa_ok then
    v_ora_error := dbms_xa.xa_getlastoer();
   dbms_output.put_line(a => 'Attention! Oracle Error - ORA-' || v_ora_error || ' obtained. XA Process failed!');
    raise v_xa_exception;
   else dbms_output.put_line(a => 'XA Process ID &1 is working!');
  end if;

  exception
    when others then
      dbms_output.put_line(a => 'A XA problem occur. Please check the error ('||v_my_transaction||') and try again. This transaction will be rolled back now!');
      v_my_transaction := dbms_xa.xa_end(xid => v_xa_xid,flag =>  dbms_xa.tmsuccess);
      v_my_transaction := dbms_xa.xa_rollback(xid => v_xa_xid);
 
      if v_my_transaction <> dbms_xa.xa_ok then
        v_ora_error := dbms_xa.xa_getlastoer();
        dbms_output.put_line(a => 'A problem occur while trying to rollback the transaction. Please try to fix error '||v_my_transaction||', ORA-' || v_ora_error || '.');
        raise_application_error(-20001, 'ORA-'||v_ora_error|| ' error when trying to rollback a transaction');
      end if;
      raise_application_error(-20002, 'ORA-'||v_ora_error||' Transaction was rolled back successfully!');

end;
/
